#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>

#define UPTIME_OID	".1.3.6.1.4.1.529.9.2"
#define USERNAME_OID	".1.3.6.1.4.1.529.12.2.1.3"
#define SESTIME_OID	".1.3.6.1.4.1.529.11.2.1.3"
#define CALLREF_OID	".1.3.6.1.4.1.529.11.2.1.4"
#define SCALLREF_OID	".1.3.6.1.4.1.529.12.2.1.7"
#define VFLAG_OID	".1.3.6.1.4.1.529.11.2.1.2"
#define HANGUP_OID	".1.3.6.1.4.1.529.12.3.1.3"

#define SNMP_PROG	"/usr/local/bin/snmpwalk -v 1"
#define SNMP_SET	"/usr/local/bin/snmpset -v 1"
#define CONF "/path/to/cgi/bin/config.cfg"
#define LOG_FILE	"/tmp/.maxkill.log" /* where to log autokills */

int find_free();
int count_groups(char *str);
char *strip_user(char *str);
char *strip_user2(char *str);
char *format_time(unsigned long up, unsigned long session);
char *find_name(char *str);
void wlog(char *str);
void clear_structs();
void read_config();

int MAXSES=0;
int MAX_CHASSIS=0;
int MUST_BE_AT_TIME=0;
char READ_COMM[20];
char RW_COMM[20];

struct {
	char hostname[32];
	char groupname[32];
	char name[32];
	int linestotal;
	int beforekill;
	} pwtable[10];
	
struct {
	int num;
	unsigned int timeonnum;
	char username[60];
	char username2[60];
	char hostname[32];
	unsigned long session_time;
	char timeon[6];
	unsigned long callref;
	unsigned long scallref;
	unsigned long uptime;
	} list[1000];

int hostindex=0;
int listindex=0;

void main(int argc, char **argv)
{
int i=1,a=0,b=0,count=0,found=0;
int high_user;
char host[32];
char high_host[32];
char timemess[30];
unsigned int hightime;
unsigned long uptime;

char line[257];
char junk1[256];
char junk2[256];
char junk3[256];
char junk4[256];
char command[256];
int group_pos=0;
int group_count=0;
int group_at=0;
int group_lines=0;
time_t tm;
FILE *pp;
FILE *pp2;

if (argc < 2) {
fprintf(stdout,"No hosts specified to check!\n");
exit(0);
}

read_config();

for (i=1;i<argc;++i) {
	clear_structs();

	strcpy(host,argv[i]);

START:
	if (group_at) 
	 a=group_pos+1;
	else
	 a=0;

	for (a;a<MAX_CHASSIS;++a) {
		if (!strcmp(pwtable[a].hostname,host)) {
		found=1;
		group_pos=0;
		group_count=0;
		group_at=0;
		break;
		}
		else if (!strcmp(pwtable[a].groupname,host)) {
		found=1;
		group_count=count_groups(host);
		group_pos=a;
		group_at++;
		/* 
		printf("In group %s (at num %d total %d) pos %d\n",host,group_at,group_count,group_pos);
		*/
		break;
		}
	} /* end of for */
	if (!found) {
	printf("Cant find host %s in table!\n",host);
	exit(0);
	}
	else {
	found=0;
	hostindex=a;
	a=0;
	}

	command[0]=0;
	line[0]=0;
	junk1[0]=0;
	junk2[0]=0;
	junk3[0]=0;
	junk4[0]=0;
	uptime=0;
	count=0;
	a=0;
	b=0;
	found=0;
	hightime=0;
	high_user=0;

	listindex=find_free();

	/* get uptime via snmp */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,UPTIME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open UPTIME pipe!\n");
		exit(0);
		}
	fgets(line,256,pp);
	pclose(pp);
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	uptime=atol(junk3);

	/* STATUS FLAGS */
	line[0]=0;
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,VFLAG_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open VFLAG pipe!\n");
		exit(0);
		}
	a=listindex;
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].num=atoi(junk3);
	strcpy(list[a].hostname,pwtable[hostindex].hostname);
	list[a].uptime=uptime;
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* SESSION TIMES */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,SESTIME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open SESTIME pipe!\n");
		exit(0);
		}
	a=listindex;
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].session_time=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* USERNAMES */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,USERNAME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open USERNAME pipe!\n");
		exit(0);
		}
	a=listindex;
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	strcpy(list[a].username,strip_user(junk3));
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* CALL REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,CALLREF_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open CALLREF pipe!\n");
		exit(0);
		}
	a=listindex;
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].callref=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* SCALL REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,SCALLREF_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open SCALLREF pipe!\n");
		exit(0);
		}
	a=listindex;
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].scallref=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* match up call reference numbers for usernames */
	for (a=listindex;a<1000;++a) {
		if (list[a].num==2) {
		/* cycle through second column of callref numbers */
		/* looking for match*/
		for (b=listindex;b<1000;++b) {
			if (list[a].callref==list[b].scallref) {
			found=1;
			break;
			}
		} /* end of sub for */
		if (found==1) {
			strcpy(list[a].username2,list[b].username);
			found=0;
			}
		found=0;
		b=0;
		} /* end of if */
	} /* end of for */
	a=0;
	b=0;

	for (a=listindex;a<1000;++a) {
	if (list[a].num==2) count++;
	}

	if (group_at) {
	group_lines+=count;
	}

	if (!group_at) {
	 if (count < pwtable[hostindex].beforekill) continue;
	}
	else if (group_at==group_count) {
	 if (group_lines < pwtable[hostindex].beforekill) {
		group_pos=0;
		group_count=0;
		group_at=0;
		continue;
		}
	}
	else if (group_at) {
	 goto START;
	}

	a=0;

	/* go through list looking for valid status flags */
	/* and setting uptimes				  */
	for (a=0;a<1000;++a) {
	strcpy(list[a].username,list[a].username2);
	if (list[a].num==2) {
	 strcpy(list[a].username,strip_user2(list[a].username));
	 /* get session time */
	 if (list[a].session_time > 0)
	  list[a].timeonnum=(list[a].uptime-list[a].session_time)/60;
	 else
	  list[a].timeonnum=0;

	 strcpy(list[a].timeon,format_time(list[a].uptime,list[a].session_time));
                if ((list[a].timeonnum > hightime) &&
		    (strlen(list[a].username))) {
                hightime=list[a].timeonnum;
                high_user=a;
		strcpy(high_host,list[a].hostname);
                }
	} /* end of if valid */
	} /* end of sub for */
	a=0;

        time(&tm);
        sprintf(timemess,"%s",ctime(&tm));
        timemess[strlen(timemess)-1]=0;

	if (group_at) a=group_lines;
	else a=count;

        /* is the user on for the lower limit? */
        if (list[high_user].timeonnum < MUST_BE_AT_TIME) {
         sprintf(junk1,"%s MAX-killer didn't disconnect user %s not high enough time on %s (%s) with time %s.  Active lines: %d\n",timemess,list[high_user].username,find_name(high_host),high_host,list[high_user].timeon,a);
        wlog(junk1);
        }
        else {
        sprintf(command,"%s %s %s %s.%ld i 1 1>/dev/null",SNMP_SET,high_host,RW_COMM,HANGUP_OID,list[high_user].callref);
        system(command);
        sprintf(junk1,"\n%s MAX-killer disconnected user %s on %s (%s) with time %s (%u). Active lines: %d\n",timemess,list[high_user].username,find_name(high_host),high_host,list[high_user].timeon,list[high_user].timeonnum,a);
        wlog(junk1);
        } /* end of else */

		group_pos=0;
		group_count=0;
		group_at=0;

   } /* end of main argc for */
} /* end of main */


midcpy(strf,strt,fr,to)
char *strf,*strt;
int fr,to;
{
int f;
for (f=fr;f<=to;++f)
  {
   if (!strf[f])
     {
      strt[f-fr]='\0';
      return;
     }
   strt[f-fr]=strf[f];
  }
strt[f-fr]='\0';
}


char *strip_user(char *str)
{
static char usern[60];

midcpy(str,usern,1,strlen(str)-2);
return usern;
}

char *strip_user2(char *str)
{
int z=0;
static char usern2[60];

for (z=0;z<strlen(str);++z) {
	if (str[z]=='@') break;
	}
midcpy(str,usern2,0,z-1);
return usern2;
}

void wlog(char *str)
{
FILE *fp;

fp=fopen(LOG_FILE,"a");
fputs(str,fp);
fclose(fp);
}

void clear_structs()
{
int z=0;

	for (z=0;z<1000;++z) {
	list[z].num=0;
	list[z].username[0]=0;
	list[z].username2[0]=0;
	list[z].hostname[0]=0;
	list[z].session_time=0;
	list[z].timeon[0]=0;
	list[z].timeonnum=0;
	list[z].callref=0;
	list[z].scallref=0;
	list[z].uptime=0;
	}
}

char *format_time(unsigned long up, unsigned long session)
{
int minutes;
int ftime_hours;
char ftime_mins[3];
static char ftime[7];

if (session==0) {
	strcpy(ftime,"0");
	goto END;
	}

minutes = (up-session)/60;

/* convert minutes to mm or hh:mm */
if (minutes < 60) {
	sprintf(ftime,"%d",minutes);
	}
else {
	ftime_hours=minutes/60;
	minutes%=60;
	if (minutes < 10)
	 sprintf(ftime_mins,"0%d",minutes);
	else
	 sprintf(ftime_mins,"%d",minutes);

	sprintf(ftime,"%d:%s",ftime_hours,ftime_mins);
     } /* end of else */

END:
return ftime;
}

void read_config()
{
int i=0,j=0;
char fileline[257];
char readbuf[256];
FILE *fp2;

if (!(fp2=fopen(CONF,"r")))
{
	printf("Can't open config file!\nerrno: %d strerrno: %s\n",errno,strerror(errno));
	exit(0);
	}
else {
	i=0;
	j=0;
	while (fgets(fileline,256,fp2) != NULL) {
		fileline[strlen(fileline)-1]=0;
	if (fileline[0]=='#' || fileline[0]==' ' || !strlen(fileline)) continue;
	else {
		if (i==0) {
		MAXSES=atoi(fileline);
		}
		else if (i==1) {
		MUST_BE_AT_TIME=atoi(fileline);
		}
		else if (i==2) {
		strcpy(READ_COMM,fileline);
		}
		else if (i==3) {
		strcpy(RW_COMM,fileline);
		}
		else if (i==4) {
		}
		else if (i >= 5) {
		sscanf(fileline,"%s ",pwtable[j].hostname);
		remove_first(fileline);
		sscanf(fileline,"%s ",readbuf);
		pwtable[j].linestotal=atoi(readbuf);
		remove_first(fileline);
		sscanf(fileline,"%s ",readbuf);
		pwtable[j].beforekill=atoi(readbuf);
		remove_first(fileline); /* before kill */
		sscanf(fileline,"%s ",pwtable[j].groupname);
		remove_first(fileline); /* group name */
		strcpy(pwtable[j].name,fileline);
		j++;
		}
		i++;
	 } /* end of else */	
	} /* end of while */
}
fclose(fp2);
MAX_CHASSIS=j-1;

}

/*** removes first word at front of string and moves rest down ***/
remove_first(inpstr)
char *inpstr;
{
int newpos,oldpos;

newpos=0;  oldpos=0;
/* find first word */
while(inpstr[oldpos]==' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find end of first word */
while(inpstr[oldpos]!=' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find second word */
while(inpstr[oldpos]==' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
while(inpstr[oldpos]!=0)
        inpstr[newpos++]=inpstr[oldpos++];
inpstr[newpos]='\0';
}

int count_groups(char *str)
{
int number=0;
int i=0;
char fileline[257];
char readbuf[256];
FILE *fp2;

if (!(fp2=fopen(CONF,"r")))
{
	printf("Can't open config file!\nerrno: %d strerrno: %s\n",errno,strerror(errno));
	exit(0);
	}
else {
	i=0;
	while (fgets(fileline,256,fp2) != NULL) {
		fileline[strlen(fileline)-1]=0;
	if (fileline[0]=='#' || fileline[0]==' ' || !strlen(fileline)) continue;
	else {
		if ((i==0) || (i==1) || (i==2) || (i==3) ||
		    (i==4)) { i++; continue; }
		else if (i >= 5) {
		remove_first(fileline); /* host */
		remove_first(fileline); /* lines total */
		remove_first(fileline); /* before kill */
		sscanf(fileline,"%s ",readbuf);
		if (!strcmp(readbuf,str)) number++;
		}
	    i++;
	 } /* end of else */	
	} /* end of while */
}
fclose(fp2);

return number;
}

int find_free()
{
int zz=0;

for (zz=0;zz<1000;++zz) {
	if (list[zz].num==0) break;
	}

return zz;
}

char *find_name(char *str)
{
int zz=0;

for (zz=0;zz<MAX_CHASSIS;++zz) {
	if (!strcmp(str,pwtable[zz].hostname)) break;
   }

return pwtable[zz].name;
}
