#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>

#define UPTIME_OID	".1.3.6.1.4.1.529.9.2"
#define USERNAME_OID	".1.3.6.1.4.1.529.12.2.1.3"
#define SESTIME_OID	".1.3.6.1.4.1.529.11.2.1.3"
#define CALLREF_OID	".1.3.6.1.4.1.529.11.2.1.4"
#define SCALLREF_OID	".1.3.6.1.4.1.529.12.2.1.7"
#define VFLAG_OID	".1.3.6.1.4.1.529.11.2.1.2"
#define HANGUP_OID	".1.3.6.1.4.1.529.12.3.1.3"

#define TXRATE_OID	".1.3.6.1.4.1.529.11.2.1.14"
#define RXRATE_OID	".1.3.6.1.4.1.529.11.2.1.5"
#define IPADDY_OID	".1.3.6.1.4.1.529.12.2.1.4"

#define SNMP_PROG	"/usr/local/bin/snmpwalk -v 1"
#define SNMP_SET	"/usr/local/bin/snmpset -v 1"
#define CONF "/path/to/cgi/bin/config.cfg"

int count_groups(char *str);
char *strip_user(char *str);
char *strip_user2(char *str);
char *get_time_as_string(void);
char *format_time(unsigned long up, unsigned long session);
void wlog(char *str);
void clear_structs();
void read_config();

char high_total='4';
int MAXSES=0;
int MAX_CHASSIS=0;
char READ_COMM[20];
char RW_COMM[20];
char URL[200];
char connlist[200][500];
char templist[200][500];
int hostindex=0;
char mess[500];

struct {
	char hostname[32];
	char groupname[32];
	char name[32];
	int linestotal;
	} pwtable[10];
	
struct {
	int num;
	char username[40];
	char username2[40];
	unsigned long session_time;
	char timeon[10];
	unsigned long callref;
	unsigned long scallref;
	unsigned long txrate;
	unsigned long rxrate;
	char ip[25];
	} list[200];

void main(int argc, char **argv)
{
int tempcount=0,timeon=0,timeon2=0;
int i=1,xx=0,a=0,b=0,count=0,found=0,j=0;
int group_pos=0;
int group_count=0;
int group_at=0;

char chunk0[500];
char host[32];
char hostdesc[50];
char timemess[30];
unsigned long uptime;

char line[257];
char templine[500];
char line2[500];
char junk1[256];
char junk2[256];
char junk3[256];
char junk4[256];
char command[256];
time_t tm;
FILE *pp;
FILE *pp2;

if (argc>1) {
fprintf(stdout,"Content-type: text/html\n\n");
          fprintf(stdout,"<HTML>\n");
          fprintf(stdout,"<HEAD>\n");   
          fprintf(stdout,"<SCRIPT LANGUAGE=\"JavaScript\">\n");
          fprintf(stdout,"function open_win(url) {\n");
          fprintf(stdout,"remote = window.open(\"\",\"remotewin\",\"width=600,height=350,scrollbars=yes\");\n");
          fprintf(stdout,"remote.location.href = url;\n");
          fprintf(stdout,"    if (remote.opener == null) remote.opener = window; \n");
          fprintf(stdout,"remote.opener.name = \"opener\";\n");
          fprintf(stdout,"}\n");
          fprintf(stdout,"</SCRIPT>\n");
          fprintf(stdout,"</HEAD>\n");
fprintf(stdout,"<BODY><center>\n");
fprintf(stdout,"<b><font size=+2>Ascend Max Port Usage</font></b><br>\n");
fprintf(stdout,"<b>%s</b>\n", get_time_as_string());
fprintf(stdout,"<br></center><br>\n");
}
else {
fprintf(stdout,"No hosts specified to check!\n");
exit(0);
}

read_config();

for (i=1;i<argc;++i) {

	strcpy(host,argv[i]);

START:
        if (group_at)
         a=group_pos+1;
        else
         a=0;

	clear_structs();
        for (xx=0;xx<200;xx++) {
		connlist[xx][0]='\0';
	}
	xx=0;
        for (xx=0;xx<200;xx++) {
		templist[xx][0]='\0';
	}

	for (a;a<MAX_CHASSIS;++a) {
                if (!strcmp(pwtable[a].hostname,host)) {
                found=1;
                group_pos=0;
                group_count=0;
                group_at=0;
                break; 
                }
                else if (!strcmp(pwtable[a].groupname,host)) {
                found=1;
                group_count=count_groups(host);
                group_pos=a;
                group_at++;
                /*
                printf("In group %s (at num %d total %d) pos %d<br>\n",host,group_at,group_count,group_pos);
		*/
                break;
                }
	} /* end of for */
	if (!found) {
	printf("Cant find host %s in table!\n",host);
	exit(0);
	}
	else {
	found=0;
	hostindex=a;
	a=0;
	}

	tempcount=0;
	timeon=0;
	timeon2=0;
	line2[0]=0;
	chunk0[0]=0;
	command[0]=0;
	line[0]=0;
	templine[0]=0;
	junk1[0]=0;
	junk2[0]=0;
	junk3[0]=0;
	junk4[0]=0;
	uptime=0;
	count=0;
	a=0;
	b=0;
	j=0;
	found=0;

	/* get uptime via snmp */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,UPTIME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open UPTIME pipe!\n");
		exit(0);
		}
	fgets(line,256,pp);
	pclose(pp);
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	uptime=atol(junk3);

	/* STATUS FLAGS */
	line[0]=0;
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,VFLAG_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open VFLAG pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].num=atoi(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* SESSION TIMES */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,SESTIME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open SESTIME pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].session_time=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* USERNAMES */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,USERNAME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open USERNAME pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	strcpy(list[a].username,strip_user(junk3));
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* CALL REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,CALLREF_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open CALLREF pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].callref=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* SCALL REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,SCALLREF_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open SCALLREF pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].scallref=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* TXRATE REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,TXRATE_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open TXRATE pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].txrate=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* RXRATE REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,RXRATE_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open RXRATE pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].rxrate=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* IPADDY REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,IPADDY_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open IPADDY pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s %s",junk1,junk2,junk3,junk4);
	line[0]=0;
	strcpy(list[a].ip,junk4);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* match up call reference numbers for usernames */
	for (a=0;a<200;++a) {
		if (list[a].num==2) {
		/* cycle through second column of callref numbers */
		/* looking for match*/
		for (b=0;b<200;++b) {
			if (list[a].callref==list[b].scallref) {
			found=1;
			break;
			}
		} /* end of sub for */
		if (found==1) {
			strcpy(list[a].username2,list[b].username);
			strcpy(list[a].ip,list[b].ip);
			found=0;
			}
		found=0;
		b=0;
		} /* end of if */
	} /* end of for */
	a=0;
	b=0;

	/* go through list looking for valid status flags */
	/* and setting uptimes				  */
	for (a=0;a<200;++a) {
	if (list[a].num==2) {
	strcpy(list[a].username,list[a].username2);
	 /* start outputting user listings here */
	 strcpy(list[a].username,strip_user2(list[a].username));
	 strcpy(list[a].timeon,format_time(uptime,list[a].session_time));
	 strcpy(connlist[count],"");
	 strcat(connlist[count],"<tr>\n");

	 sprintf(mess,URL,pwtable[hostindex].hostname,list[a].username,list[a].callref);
	 sprintf(templine,"<td><a href=\"javascript:open_win('%s');\">%s</a></td>",mess,list[a].username);
	 strcat(connlist[count],templine);

	 sprintf(templine,"<td>%-6d</td>",list[a].txrate);
	 strcat(connlist[count],templine);
	 sprintf(templine,"<td>%-6d</td>",list[a].rxrate);
	 strcat(connlist[count],templine);
	 sprintf(templine,"<td>%-16s</td>",list[a].ip);
	 strcat(connlist[count],templine);

                if ((strlen(list[a].timeon) > 4) || ((strlen(list[a].timeon) == 4)
                        && (list[a].timeon[0]>=high_total) )) {
                sprintf(templine,"<td><font color=\"#FF0000\"><b><!---->%s</b></font></td>",list[a].timeon);
                strcat(connlist[count],templine);
                }
                else {
                  sprintf(templine,"<td><!---->%s</td>",list[a].timeon);
                  strcat(connlist[count],templine);
                  }

	 strcat(connlist[count],"</tr>\n");
         connlist[count][strlen(connlist[count])]=0;
	 count++;
	 } /* end of if status is 2 */
	} /* end of sub for */
	a=0;

	/* sort session list by time */
	j=0; tempcount=0; found=0;

	if (strlen(connlist[0])) {
                  strcpy(templist[tempcount],connlist[j]);
	}
                j++;

                while (strlen(connlist[j])) {
                        a=0; b=0;
                        timeon=0;
                        line2[0]=0;
                        chunk0[0]=0;
                  /* check time from stored line */
                  strcpy(line2,connlist[j]);
                  for (a=0;a<strlen(line2);++a) {
                        if (line2[a]=='!') { a=a+6; break; }
                        } /* end of for */
                  b=a;
                  for (b;b<strlen(line2);++b) {
                        if (line2[b]=='<') break;
                        }
                        
                  midcpy(line2,chunk0,a,b-1);
                  a=0; b=0;
                  timeon=convert_time(chunk0);   
                  while (!found) {
                        timeon2=0;
                        line2[0]=0;
                        chunk0[0]=0;
                  /* GET TIME FROM LIST ITEM */
                  /* check time from stored line */
                        if (!strlen(templist[tempcount])) goto COPYEND;
                  strcpy(line2,templist[tempcount]);

                  for (a=0;a<strlen(line2);++a) {
                        if (line2[a]=='!') { a=a+6; break; }
                        } /* end of for */
                  b=a;
                  for (b;b<strlen(line2);++b) {
                        if (line2[b]=='<') break;
                        } /* end of for */
                        
                  midcpy(line2,chunk0,a,b-1);
                  a=0; b=0;
                  timeon2=convert_time(chunk0);  
                  if (timeon >= timeon2) {
                         move_down(tempcount);
		COPYEND:
                        strcpy(templist[tempcount],connlist[j]);
                        found=1;
                        }
                  else {
                        tempcount++;
                        }
                  } /* end of sub-while */
                j++;
                tempcount=0;
                found=0; 
                } /* end of while */
                j=0;

                copy_list();

		print_header();
                print_users();   
		/* print cumulative modem usage */
          fprintf(stdout,"<tr><td bgcolor=\"#ffafaf\" colspan=9><font size=+1 color=\"#000000\"><b>Active modems: %d &nbsp;&nbsp; Free modems: %d</b></font></td></tr>",
	  count,pwtable[hostindex].linestotal-count);
          fprintf(stdout,"</TABLE>\n</center>");

                clear_list();

if (!group_at) continue;
else if (group_at==group_count) {
		/*
		printf("This is the last host in group (%s:%d)<br>\n",pwtable[hostindex].name,group_at);
		*/
                group_pos=0;
                group_count=0;
                group_at=0;
                continue;
}
else if (group_at) {
         goto START;
}

   } /* end of main argc for */

fprintf(stdout,"</BODY>\n</HTML>\n\n");

} /* end of main */


midcpy(strf,strt,fr,to)
char *strf,*strt;
int fr,to;
{
int f;
for (f=fr;f<=to;++f)
  {
   if (!strf[f])
     {
      strt[f-fr]='\0';
      return;
     }
   strt[f-fr]=strf[f];
  }
strt[f-fr]='\0';
}


char *strip_user(char *str)
{
static char usern[40];

midcpy(str,usern,1,strlen(str)-2);
return usern;
}

char *strip_user2(char *str)
{
int z=0;
static char usern2[40];

for (z=0;z<strlen(str);++z) {
	if (str[z]=='@') break;
	}
midcpy(str,usern2,0,z-1);
return usern2;
}

void wlog(char *str)
{
FILE *fp;

fp=fopen("/tmp/.maxchk.log","a");
fputs(str,fp);
fclose(fp);
}

void clear_structs()
{
int z=0;

	for (z=0;z<200;++z) {
	list[z].num=0;
	list[z].username[0]=0;
	list[z].username2[0]=0;
	list[z].session_time=0;
	list[z].timeon[0]=0;
	list[z].callref=0;
	list[z].scallref=0;
	list[z].txrate=0;
	list[z].rxrate=0;
	list[z].ip[0]=0;
	}
}

char *format_time(unsigned long up, unsigned long session)
{
int minutes;
int ftime_hours;
char ftime_mins[3];
static char ftime[7];

if (session==0) {
	strcpy(ftime,"0");
	goto END;
	}

minutes = (up-session)/60;

/* convert minutes to mm or hh:mm */
if (minutes < 60) {
	sprintf(ftime,"%d",minutes);
	}
else {
	ftime_hours=minutes/60;
	minutes%=60;
	if (minutes < 10)
	 sprintf(ftime_mins,"0%d",minutes);
	else
	 sprintf(ftime_mins,"%d",minutes);

	sprintf(ftime,"%d:%s",ftime_hours,ftime_mins);
     } /* end of else */

END:
return ftime;
}

move_down(pos)
int pos;
{
int found=0;
int jj=0;
int aa=MAXSES-1;

for (aa;aa>=0;--aa) {
        if (strlen(templist[aa])) { found=1; break; }
        }

if (found) {
  while (aa >= pos) {
  strcpy(templist[aa+1],templist[aa]);
  aa--;
  } /* end of while */
} /* end of if */

found=0;
aa=0;
} 

copy_list()
{    
int i=0;
int j=0;
        
/* now copy them all back to the original list */
for (i=0;i<pwtable[hostindex].linestotal;++i) {
   if (strlen(templist[i])) {
        strcpy(connlist[j],templist[i]);
        j++;
        }  
   else break;
   } /* end of for */
/* clear any not used rows */
for (i=j;i<pwtable[hostindex].linestotal;++i) connlist[i][0]=0;
/* clear templist so we can use it again later */
for (i=0;i<pwtable[hostindex].linestotal;++i) templist[i][0]=0;
   
}

clear_list()
{
int i=0;
int j=0;

/* clear templist so we can use it again later */
for (i=0;i<pwtable[hostindex].linestotal;++i) templist[i][0]=0;
/* clear connection list so we can use it again later */
for (i=0;i<pwtable[hostindex].linestotal;++i) connlist[i][0]=0;

}

print_users()
{
int i=0;

while (strlen(connlist[i])) {
        fprintf(stdout,connlist[i]);
        fflush(stdout);
        i++;
        } /* end of while */

}

convert_time(str)
char *str;
{
int a=0;
int numchunk1=0;
int numchunk2=0;
char chunk1[10];
char chunk2[10];
                        
                  if (strstr(str,":")) {
                        for (a=0;a<strlen(str);++a) {
                          if (str[a]==':') break;
                          } /* end of for */
                        /* copy hours and minutes to memory */
                        midcpy(str,chunk1,0,a-1);
                        midcpy(str,chunk2,a+1,strlen(str));

                        /* change to numeric */
                        numchunk1=atoi(chunk1); /* hour */
                        numchunk1=numchunk1*60; /* change hour to minutes */
                        numchunk2=atoi(chunk2); /* extra minutes */
                        /* calculate online time in minutes */
                        numchunk1=numchunk1+numchunk2;
                    } /* end of it strstr colon */
                  else if (strstr(str,"-")) { numchunk1=0; }
                  else { numchunk1=atoi(str); }

return numchunk1;
}

print_header()
{

          fprintf(stdout,"<br><center><TABLE BORDER=1>\n");
          fprintf(stdout,"<tr><td colspan=9><font size=+1><b>%s (%s)</b></font></td></tr>",
                   pwtable[hostindex].name,pwtable[hostindex].hostname);
          fprintf(stdout,"<tr bgcolor=\"#ffafaf\">\n<td><b>Username</b></td>
                <td><b>TX Rate</b></td><td><b>RX Rate</b></td>
                <td><b>Hostname</b></td><td><b>Session Time</b></td>    
                </tr>\n");

}

char *get_time_as_string(void)
{
    time_t now;
    char *timestring;
          
    time(&now);
    timestring = ctime(&now);
          
    timestring[strlen(timestring) - 1] = '\0'; /*trim newline at end*/

    return timestring;
}

void read_config()
{
int yy=0,zz=0;
char fileline[257];
char readbuf[256];
FILE *fp2;
        
/*
if (!(fp2=fopen("/path/to/cgi/bin/config.cfg","r")))
*/
if (!(fp2=fopen(CONF,"r")))
{
        printf("Can't open config file!<br>\n</BODY></HTML>\n");
        exit(0);
        }
else {
        yy=0;
        zz=0;
        while (fgets(fileline,256,fp2) != NULL) {
                fileline[strlen(fileline)-1]=0;
        if (fileline[0]=='#' || fileline[0]==' ' || !strlen(fileline)) continue;
        else {
                if (yy==0) {
                MAXSES=atoi(fileline);
                }
                else if (yy==1) {
                }
                else if (yy==2) {
		strcpy(READ_COMM,fileline);
                }
                else if (yy==3) {
		strcpy(RW_COMM,fileline);
                }
                else if (yy==4) {
		strcpy(URL,fileline);
                }
                else if (yy >= 5) {
                sscanf(fileline,"%s ",pwtable[zz].hostname);
                remove_first(fileline);
                sscanf(fileline,"%s ",readbuf);
                pwtable[zz].linestotal=atoi(readbuf);
                remove_first(fileline);
		/* dont scan in beforekill line, we dont need it */
                remove_first(fileline); /* before kill */
                sscanf(fileline,"%s ",pwtable[zz].groupname);  
                remove_first(fileline); /* group name */
                strcpy(pwtable[zz].name,fileline);
                zz++;
                }
                yy++;
         } /* end of else */
        } /* end of while */
}
fclose(fp2);
MAX_CHASSIS=zz;
}

/*** removes first word at front of string and moves rest down ***/
remove_first(inpstr)
char *inpstr;
{
int newpos,oldpos;

newpos=0;  oldpos=0;
/* find first word */
while(inpstr[oldpos]==' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find end of first word */
while(inpstr[oldpos]!=' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find second word */
while(inpstr[oldpos]==' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
while(inpstr[oldpos]!=0)
        inpstr[newpos++]=inpstr[oldpos++];
inpstr[newpos]='\0';
}

int count_groups(char *str)
{
int number=0;
int i=0;
char fileline[257];
char readbuf[256];
FILE *fp2;
        
if (!(fp2=fopen(CONF,"r")))
{               
        printf("Can't open config file!\nerrno: %d strerrno: %s\n",errno,strerror(errno));
        exit(0);
        }
else {
        i=0;
        while (fgets(fileline,256,fp2) != NULL) {
                fileline[strlen(fileline)-1]=0;
        if (fileline[0]=='#' || fileline[0]==' ' || !strlen(fileline)) continue;
        else {
                if ((i==0) || (i==1) || (i==2) || (i==3) ||
                    (i==4)) { i++; continue; }
                else if (i >= 5) {
                remove_first(fileline); /* host */
                remove_first(fileline); /* lines total */
                remove_first(fileline); /* before kill */
                sscanf(fileline,"%s ",readbuf);  
                if (!strcmp(readbuf,str)) number++;
                }
            i++;
         } /* end of else */
        } /* end of while */
}
fclose(fp2);
                
return number;
}

