#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>

#define UPTIME_OID	".1.3.6.1.4.1.529.9.2"
#define USERNAME_OID	".1.3.6.1.4.1.529.12.2.1.3"
#define SESTIME_OID	".1.3.6.1.4.1.529.11.2.1.3"
#define CALLREF_OID	".1.3.6.1.4.1.529.11.2.1.4"
#define SCALLREF_OID	".1.3.6.1.4.1.529.12.2.1.7"
#define VFLAG_OID	".1.3.6.1.4.1.529.11.2.1.2"
#define HANGUP_OID	".1.3.6.1.4.1.529.12.3.1.3"

#define SNMP_PROG	"/usr/local/bin/snmpwalk -v 1"
#define SNMP_SET	"/usr/local/bin/snmpset -v 1"
#define CONF "/path/to/cgi/bin/config.cfg"

char *strip_user(char *str);
char *strip_user2(char *str);
char *format_time(unsigned long up, unsigned long session);
void wlog(char *str);
void clear_structs();
void read_config();

int MAXSES=0;
int MAX_CHASSIS=0;
char READ_COMM[20];
char RW_COMM[20];

struct {
	char hostname[32];
	char name[32];
	int linestotal;
	} pwtable[10];
	
struct {
	int num;
	char username[40];
	char username2[40];
	unsigned long session_time;
	char timeon[6];
	unsigned long callref;
	unsigned long scallref;
	} list[200];

int hostindex=0;

void main(int argc, char **argv)
{
int i=1,a=0,b=0,count=0,found=0;
char timemess[30];
unsigned long uptime;

char hostname[64];
char username[21];
char callref[15];
unsigned long callrefnum;
char line[257];
char junk1[256];
char junk2[256];
char junk3[256];
char junk4[256];
char command[256];
time_t tm;
FILE *pp;
FILE *pp2;

if (argc!=2) {
  exit(0);
 }

read_config();

/* Parse fields */
for (i=0;i<strlen(argv[1]);++i) {
   if (argv[1][i]=='_') break;
  }
midcpy(argv[1],hostname,0,i-1);
remove_first2(argv[1]);
i=0;
for (i=0;i<strlen(argv[1]);++i) {
   if (argv[1][i]=='_') break;
  }
midcpy(argv[1],username,0,i-1);
remove_first2(argv[1]);
i=0;
for (i=0;i<strlen(argv[1]);++i) {
   if (argv[1][i]=='_') break;
  }
midcpy(argv[1],callref,0,strlen(argv[1])+1);
remove_first2(argv[1]);
i=0;

printf("Content-type: text/html\n\n");
printf("<HTML><BODY>\n");

        for (a=0;a<MAX_CHASSIS;++a) {
                if (!strcmp(pwtable[a].hostname,hostname)) {
                found=1;
                break;
                }
        } /* end of for */
        if (!found) {
        printf("Cant find host %s in table!<br>\n",hostname);
	printf("</BODY></HTML>\n");
        exit(0);
        }
        else {
        found=0;
        hostindex=a;
        a=0;
        }

callrefnum=atol(callref);

	/* get uptime via snmp */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,UPTIME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open UPTIME pipe!\n");
		exit(0);
		}
	fgets(line,256,pp);
	pclose(pp);
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	uptime=atol(junk3);

	/* STATUS FLAGS */
	line[0]=0;
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,VFLAG_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open VFLAG pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].num=atoi(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* SESSION TIMES */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,SESTIME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open SESTIME pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].session_time=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* USERNAMES */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,USERNAME_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open USERNAME pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	strcpy(list[a].username,strip_user(junk3));
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* CALL REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,CALLREF_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open CALLREF pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].callref=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* SCALL REFERENCE NUMBERS */
	sprintf(command,"%s %s %s %s",SNMP_PROG,pwtable[hostindex].hostname,READ_COMM,SCALLREF_OID);
	if (!(pp=popen(command,"r"))) {
		printf("Can't open SCALLREF pipe!\n");
		exit(0);
		}
	while (fgets(line,256,pp) != NULL) {
	line[strlen(line)-1]=0;
	sscanf(line,"%s %s %s",junk1,junk2,junk3);
	line[0]=0;
	list[a].scallref=atol(junk3);
	a++;
	} /* end of while */
	pclose(pp);
	a=0;

	/* match up call reference numbers for usernames */
	for (a=0;a<200;++a) {
		if (list[a].num==2) {
		/* cycle through second column of callref numbers */
		/* looking for match*/
		for (b=0;b<200;++b) {
			if (list[a].callref==list[b].scallref) {
			found=1;
			break;
			}
		} /* end of sub for */
		if (found==1) {
			strcpy(list[a].username2,list[b].username);
			found=0;
			}
		found=0;
		b=0;
		} /* end of if */
	} /* end of for */
	a=0;
	b=0;

	for (a=0;a<200;++a) {
	if (list[a].num==2) count++;
	}

	a=0;

	/* go through list looking for valid status flags */
	/* and setting uptimes				  */
	for (a=0;a<200;++a) {
	strcpy(list[a].username,list[a].username2);
	strcpy(list[a].username,strip_user2(list[a].username));
	if (callrefnum==list[a].callref) {
	 /* get session time */
	 strcpy(list[a].timeon,format_time(uptime,list[a].session_time));
	 found=1;
	 break;
	} /* end of if is callref */
	} /* end of sub for */

	if (!found) {
	printf("Can't find call reference number %u!<br>\n",callrefnum);
	printf("</BODY></HTML>\n");
	exit(0);
	}

        time(&tm);
        sprintf(timemess,"%s",ctime(&tm));
        timemess[strlen(timemess)-1]=0;

        sprintf(command,"%s %s %s %s.%ld i 1 1>/dev/null",SNMP_SET,pwtable[hostindex].hostname,RW_COMM,HANGUP_OID,list[a].callref);
        system(command);
        printf("User %s disconnected from %s<br>\n",list[a].username,pwtable[hostindex].name);
        sprintf(junk1,"\n%s Port-killer disconnected user %s on %s (%s) with time %s. Active lines: %d\n",timemess,list[a].username,pwtable[hostindex].name,pwtable[hostindex].hostname,list[a].timeon,count);
        wlog(junk1);                 

} /* end of main */


midcpy(strf,strt,fr,to)
char *strf,*strt;
int fr,to;
{
int f;
for (f=fr;f<=to;++f)
  {
   if (!strf[f])
     {
      strt[f-fr]='\0';
      return;
     }
   strt[f-fr]=strf[f];
  }
strt[f-fr]='\0';
}


char *strip_user(char *str)
{
static char usern[40];

midcpy(str,usern,1,strlen(str)-2);
return usern;
}

char *strip_user2(char *str)
{
int z=0;
static char usern2[40];

for (z=0;z<strlen(str);++z) {
	if (str[z]=='@') break;
	}
midcpy(str,usern2,0,z-1);
return usern2;
}

void wlog(char *str)
{
FILE *fp;

fp=fopen("/tmp/.maxchk.log","a");
fputs(str,fp);
fclose(fp);
}

void clear_structs()
{
int z=0;

	for (z=0;z<200;++z) {
	list[z].num=0;
	list[z].username[0]=0;
	list[z].username2[0]=0;
	list[z].session_time=0;
	list[z].timeon[0]=0;
	list[z].callref=0;
	list[z].scallref=0;
	}
}

char *format_time(unsigned long up, unsigned long session)
{
int minutes;
int ftime_hours;
char ftime_mins[3];
static char ftime[7];

if (session==0) {
	strcpy(ftime,"0");
	goto END;
	}

minutes = (up-session)/60;

/* convert minutes to mm or hh:mm */
if (minutes < 60) {
	sprintf(ftime,"%d",minutes);
	}
else {
	ftime_hours=minutes/60;
	minutes%=60;
	if (minutes < 10)
	 sprintf(ftime_mins,"0%d",minutes);
	else
	 sprintf(ftime_mins,"%d",minutes);

	sprintf(ftime,"%d:%s",ftime_hours,ftime_mins);
     } /* end of else */

END:
return ftime;
}

/*** removes first word at front of string and moves rest down ***/
remove_first2(inpstr)
char *inpstr;
{
int newpos,oldpos;
          
newpos=0;  oldpos=0;  
/* find first word */
while(inpstr[oldpos]=='_') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find end of first word */
while(inpstr[oldpos]!='_') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find second word */
while(inpstr[oldpos]=='_') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
while(inpstr[oldpos]!=0)
        inpstr[newpos++]=inpstr[oldpos++];
inpstr[newpos]='\0';
}

/*** removes first word at front of string and moves rest down ***/
remove_first(inpstr)
char *inpstr;
{
int newpos,oldpos;

newpos=0;  oldpos=0;
/* find first word */
while(inpstr[oldpos]==' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find end of first word */
while(inpstr[oldpos]!=' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
/* find second word */
while(inpstr[oldpos]==' ') {
        if (!inpstr[oldpos]) { inpstr[0]=0;  return; }
        oldpos++;
        }
while(inpstr[oldpos]!=0)
        inpstr[newpos++]=inpstr[oldpos++];
inpstr[newpos]='\0';
}

void read_config()
{
int yy=0,zz=0;
char fileline[257];
char readbuf[256];
FILE *fp2;
        
if (!(fp2=fopen(CONF,"r"))) {
        printf("Can't open config file!<br>\nerrno: %d strerrno: %s<br>\n</BODY></HTML>\n",errno,strerror(errno));
        exit(0);
        }
else {
        yy=0;
        zz=0;
        while (fgets(fileline,256,fp2) != NULL) {
                fileline[strlen(fileline)-1]=0;
        if (fileline[0]=='#' || fileline[0]==' ' || !strlen(fileline)) continue;
        else {
                if (yy==0) {
                MAXSES=atoi(fileline);
                }
                else if (yy==1) {
                }
                else if (yy==2) {
                strcpy(READ_COMM,fileline);
                }
                else if (yy==3) {
                strcpy(RW_COMM,fileline);
                }
                else if (yy==4) {
                }
                else if (yy >= 5) {
                sscanf(fileline,"%s ",pwtable[zz].hostname);
                remove_first(fileline);
                sscanf(fileline,"%s ",readbuf);
                pwtable[zz].linestotal=atoi(readbuf);
                remove_first(fileline);
                /* dont scan in beforekill line, we dont need it */
                remove_first(fileline);
                /* dont scan in group line, we dont need it */
                remove_first(fileline);
                strcpy(pwtable[zz].name,fileline);
                zz++;
                }
                yy++;
         } /* end of else */
        } /* end of while */
}
fclose(fp2);
MAX_CHASSIS=zz-1;
}


